#pragma onc
#include <string>

using namespace std;

class Goblin
{
public:
	//Constructeur - toujours appel automatiquement lors de la construction.
	Goblin();
	//Overload du constructeur possible
	//TOUJOURS: Passer un const & pour toutes les non primitives
	//Si on passe string ou const string, la string sera copie.
	Goblin(const string& InName);
	//Destructeur - toujours appel lors de la destruction.
	~Goblin();


	//const string&: retourne une RFRENCE (et non une copie) de la string. La string ne peut pas tre modifie
	// grce au const. Autrement, a reviendrait  modifier la string de l'instance de l'extrieur ce qui n'est
	//pas idal
	//GetName() const: L'instance courrante (le this) n'est pas modifi.
	const string&  GetName() const;


	//GetLife() const: L'instance courrante (le this) n'est pas modifi.
	int GetLife() const;
	//Ici, on modifie le membre _Life donc on ne peut pas faire void SetLife(int InLife) const;
	void SetLife(int InLife);

private:
	//Une constante initialise dans la dclaration de classe.
	const string _Name = "GoblinNoName";
	int _Life = 10;
};

